% \iffalse meta-comment
% temfmacros.dtx
% Copyright 2021 Jonas Bundschuh
%
% This work may be distributed and/or modified under the
% conditions of the LaTeX Project Public License, either version 1.3
% of this license or (at your option) any later version.
% The latest version of this license is in
% http://www.latex-project.org/lppl.txt
% and version 1.3 or later is part of all distributions of LaTeX
% version 2005/12/01 or later.
%
% This work has the LPPL maintenance status `author-maintained'.
%
% The Current Maintainer of this work is Jonas Bundschuh
%
% This work consists of the files temfmacros.dtx and temfmacros.ins
% and the derived file temfmacros.sty.
%
% Author: Jonas Bundschuh
% TU Darmstadt, TEMF
% Mail: jonas.bundschuh@tu-darmstadt.de
% \fi
% \iffalse
%<*package>
\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{macros}[2020/11/18 TEMF Makros]

%</package>
%<*driver>
\ProvidesFile{macros.dtx}[1.0 My package]
\documentclass{ltxdoc}
\usepackage{xcolor}
\usepackage{tabulary}
\usepackage{longtable}
\usepackage{csquotes}
\usepackage[all]{temfmacros}
\usepackage{cprotect}
\usepackage[colorlinks=false,allbordercolors=white]{hyperref}
%%%\CodelineIndex
\PageIndex
\AtBeginEnvironment{macrocode}{\color{red}}
\begin{document}
	\DeleteShortVerb{\|}
	\DocInput{\jobname.dtx}
\end{document}
%</driver>
% \fi
%
% \EnableCrossrefs
% \CheckSum{0}
%
% \CharacterTable
%  {Upper-case    \A\B\C\D\E\F\G\H\I\J\K\L\M\N\O\P\Q\R\S\T\U\V\W\X\Y\Z
%   Lower-case    \a\b\c\d\e\f\g\h\i\j\k\l\m\n\o\p\q\r\s\t\u\v\w\x\y\z
%   Digits        \0\1\2\3\4\5\6\7\8\9
%   Exclamation   \!     Double quote  \"     Hash (number) \#
%   Dollar        \$     Percent       \%     Ampersand     \&
%   Acute accent  \'     Left paren    \(     Right paren   \)
%   Asterisk      \*     Plus          \+     Comma         \,
%   Minus         \-     Point         \.     Solidus       \/
%   Colon         \:     Semicolon     \;     Less than     \<
%   Equals        \=     Greater than  \>     Question mark \?
%   Commercial at \@     Left bracket  \[     Backslash     \\
%   Right bracket \]     Circumflex    \^     Underscore    \_
%   Grave accent  \`     Left brace    \{     Vertical bar  \|
%   Right brace   \}     Tilde         \~}
%
%
% \GetFileInfo{temfmacros.sty}
%
% \DoNotIndex{\#,\$,\%,\&,\@,\\,\{,\},\^,\_,\~,\ }
% \DoNotIndex{\@ne}
% \DoNotIndex{\advance,\begingroup,\catcode,\closein}
% \DoNotIndex{\closeout,\day,\def,\edef,\else,\empty,\endgroup}
% \DoNotIndex{\DeclareOption,\CurrentOption,\renewcommand,\newcommand}
%
% \GetFileInfo{temfmacros.sty}
%
% \title{Documentation of the \textsf{temfmacros} package.}
% \author{Jonas Bundschuh}
% 
% \maketitle
% 
% \tableofcontents
% 
% \section{Usage of the package}
% 
% The package is loaded as a normal package with 
%\begin{center}
%    \verb*|\usepackage[options]{temfmacros}|.
%\end{center} 
% If the \texttt{.sty} file has not been created yet, i.e. when you only have a \texttt{.dtx} and a \texttt{.ins} file, the \texttt{.sty} file has to be created first. For that, start your console and navigate to the folder in which the \texttt{.dtx} and the \texttt{.ins} file are. Then execute the command 
%\begin{center}
%    \texttt{latex temfmacros.ins}
%\end{center}
% This will generate the \texttt{.sty} file. After that you can either move it to the projects directory or to a directory searched by \TeX. 
%
% \section{Options}
% There are several options for the package. With every option the available macros are extended. There are the following options:
% \begin{itemize}
%	\item \nameref{sec:all}
%	\item \nameref{sec:spaces}
%	\item \nameref{sec:operators}
% \end{itemize}
%
% \subsection{main}
% The macros presented in this section are privided independently of the passed options to the package. They constitute the main macros and cannot be deselected. 
% \begin{macro}{\cmplx}
% \verb*|\cmplx|\marg{arg}\\
% Macro for complex numbers. Example: \verb*|\cmplx{a}| gives \cmplx{a}
% \end{macro}
% \begin{macro}{\tensor}
% \verb*|\tensor|\marg{arg}\\
% Macro for a tensor. Example: \verb*|\tensor{a}| gives \tensor{a}
% \end{macro}
%
% \begin{macro}{\i\j}
% The imaginary unit \i or \j and the Euler number \e upright. 
% \end{macro}
%
% \begin{macro}{\e}
% The Euler number \e upright.
% \end{macro}
% 
% There are four greek letters that come in two versions. A \enquote{normal} version and a \enquote{variable} version. An example is phi with \verb*|\phi| giving $\phi$ and \verb*|\varphi| giving $\varphi$. However, if you for example always want to use the $\varphi$ in your document you don't want to write \verb*|\varphi| but rather \verb*|\phi|. Redefining the command is possible but not recommended. The follwoing macros provide a solution. 
% \begin{macro}{\phi}
% \begin{macro}{\epsilon}
% \begin{macro}{\theta}
% \begin{macro}{\rho}
% For each command a boolean variable has been defined:\label{greek_letters}
% \begin{itemize}
%    \item \texttt{varphi}
%    \item \texttt{varepsilon}
%    \item \texttt{vartheta}
%    \item \texttt{varrho}
%\end{itemize}
% These control whether the \enquote{normal} or the \enquote{variable} version is printed. All are initialized with \texttt{false}. Thus, initially the command \verb*|\phi| produces $\phi$. 
%
% Each boolean varible \texttt{var} can be set to \texttt{true} with \verb*|\booltrue{var}| and to \texttt{false} with \verb*|\boolfalse{var}|. 
% 
% After the command \verb*|\booltrue{varphi}|\booltrue{varphi} for example, the command \verb*|\phi| produces $\phi$ until \texttt{varphi} is set to \texttt{false} again. 
%
% To avoid too many redefinitions of the boolean variables, each command comes with an optional argument to produce a certain form. The syntax is then \begin{center}\verb*|\phi|\oarg{opt. arg}\end{center}
% with \oarg{opt. arg} being \texttt{norm} and \texttt{var}, producing $\phi[norm]$ and $\phi[var]$, respectively. 
%
% Example: \boolfalse{varphi}\\
% 
% \begin{minipage}{.55\textwidth}
% \begin{verbatim}
% $\phi$, $\phi[norm]$ and $\phi[var]$.\\
% Switching: \booltrue{varphi}\\
% $\phi$, $\phi[norm]$ and $\phi[var]$.\\
% Switching \boolfalse{varphi}\\
% $\phi$, $\phi[norm]$ and $\phi[var]$. 
% \end{verbatim}
% \end{minipage}
% \hspace{1cm}
% \fbox{\begin{minipage}{.2\textwidth}
% $\phi$, $\phi[norm]$ and $\phi[var]$.\\
% Switching \booltrue{varphi}\\
% $\phi$, $\phi[norm]$ and $\phi[var]$.\\
% Switching \boolfalse{varphi}\\
% $\phi$, $\phi[norm]$ and $\phi[var]$. 
% \end{minipage}} 
% \end{macro}
% \end{macro}
% \end{macro}
% \end{macro}
%
% The macros defined from now on can be assiciated to categories.
% \paragraph{spaces}
% \begin{macro}{\nat}
% \begin{macro}{\integer}
% \begin{macro}{\rational}
% \begin{macro}{\real}
% \begin{macro}{\complex}
% Macros for some spaces:\\
% \begin{center}\begin{tabular}{|c|c|}
%    \hline Command & Symbol \\\hline\hline
%    \verb*|\nat|  & \nat\\\hline
%    \verb*|\integer| & \integer\\\hline
%    \verb*|\rational| & \rational\\\hline
%    \verb*|\real| & \real\\\hline
%    \verb*|\complex| & \complex\\\hline
% \end{tabular}\end{center}
% \end{macro}
% \end{macro}
% \end{macro}
% \end{macro}
% \end{macro}
% 
% \paragraph{Operators}
% \begin{macro}{\norm}\label{mac:norm}
% \verb*|\norm|\marg{arg}\\
% A macro for a norm. Example: \verb*|\norm{f}| gives \norm{f}
% \end{macro}
%
% \begin{macro}{\abs}
% \verb*|\abs|\marg{arg}\\
% A macro for the absolute value. Example: \verb*|\abs{f}| gives \abs{f}
% \end{macro}
%
% \begin{macro}{\innerprod}
% \verb*|\innerprod|\marg{arg1}\marg{arg2}\\
% A macro for the inner product. Example: \verb*|\innerprod{f}{g}| gives \innerprod{f}{g}
% \end{macro}
%
% \begin{macro}{\set}
% \verb*|\set|\marg{arg1}\\
% A macro for a set. Example: \verb*|\set{1,2,3}| gives \set{1,2,3}
% \end{macro}
%
% \begin{macro}{\supp}
% \begin{macro}{\spn}
% \begin{macro}{\landau}
% These macros are math opterators:
% \begin{center}\begin{tabular}{|c|c|}
%   	\hline Command & Symbol \\\hline\hline
% 		\verb*|\supp| & $\supp$\\\hline
% 		\verb*|\spn| & $\spn$\\\hline
%		\verb*|\landau| & $\landau$\\\hline
% \end{tabular}\end{center}
% \end{macro}
% \end{macro}
% \end{macro}
% 
% \paragraph{Differential operators}
% \begin{macro}{\diff}
% Provides the upright \diff 
% \end{macro}
% 
% \begin{macro}{\dd}
% Syntax: \verb*|\dd|\oarg{multiplicity}\marg{function}\marg{variable}\\
% Provides a macro for the total derivative of a function with respect to a variable. The argument \oarg{multiplicity} is optional. Examples:\\\renewcommand{\arraystretch}{1.5}
% \begin{center}\begin{tabular}{|c|c|}
%   	\hline Command & Symbol \\\hline\hline
% 		\verb*|\dd{f}{x}| & \dd{f}{x}\\\hline
% 		\verb*|\dd[2]{f}{x}| & \dd[2]{f}{x}\\\hline
% \end{tabular}\end{center}
% \end{macro}
% 
% \begin{macro}{\pp}
% Syntax: \verb*|\pp|\oarg{multiplicity}\marg{function}\marg{variable}\\
% Provides a macro for the partial derivative of a function with respect to a variable. The argument \oarg{multiplicity} is optional. Examples:\\\renewcommand{\arraystretch}{1.5}
% \begin{center}\begin{tabular}{|c|c|}
        %   	\hline Command & Symbol \\\hline\hline
        % 		\verb*|\pp{f}{x}| & \pp{f}{x}\\\hline
        % 		\verb*|\pp[2]{f}{x}| & \pp[2]{f}{x}\\\hline
        % \end{tabular}\end{center}
% \end{macro}
% \begin{macro}{\Grad}
% \begin{macro}{\Div}
% \begin{macro}{\Rot}
% \begin{macro}{\Curl}
% The functionality of these macros is very similar to those of the thwo versions of some greek letters (see page \pageref{greek_letters}). Here, the boolean variable \texttt{nabla} has been defined. It controls whether a word of the expression with $\nabla$ is used. It is initialised as \texttt{false} and can be set to to \texttt{true} with \verb*|\booltrue{nabla}| and to \texttt{false} with \verb*|\boolfalse{nabla}|. 
%
% Each command can take one optional argument to produce a certain form without redefining the boolean variables. Only the arguments \texttt{nabla} and \texttt{word} are accepted. Example:
% \verb*|\Div[nabla]f| gives $\Div[nabla]f$ and \verb*|\Div[word]f| gives $\Div[word]f$\\
% Another example:\\
% 
% \begin{minipage}{.55\textwidth}
% \begin{verbatim}
% $\Div f$, $\Div[nabla]f$ and $\Div[word]f$\\
% Switching \booltrue{nabla}\\
% $\Div f$, $\Div[nabla]f$ and $\Div[word]f$\\
% Switching \boolfalse{nabla}\\
% $\Div f$, $\Div[nabla]f$ and $\Div[word]f$ 
%    \end{verbatim}
% \end{minipage}
% \hspace{1cm}
% \fbox{\begin{minipage}{.3\textwidth}
% $\Div f$, $\Div[nabla]f$ and $\Div[word]f$\\
% Switching \booltrue{nabla}\\
% $\Div f$, $\Div[nabla]f$ and $\Div[word]f$\\
% Switching \boolfalse{nabla}\\
% $\Div f$, $\Div[nabla]f$ and $\Div[word]f$ 
% \end{minipage}} 
% \end{macro}
% \end{macro}
% \end{macro}
% \end{macro}
% 
% \paragraph{Vectors}
% \begin{macro}{\vect}
% \verb*|\vect|\marg{arg}\\
% A macro for vectors. Example: \verb*|\vect{a}| gives \vect{a}
% \end{macro}
%
% \begin{macro}{\cmplxvect}
% \verb*|\cmplxvect|\marg{arg}\\
% A macro for complex vectors. Example: \verb*|\cmplxvect{a}| gives \cmplxvect{a}
% \end{macro}
%
% \paragraph{Matrices}
% \begin{macro}{\mat}
% \verb*|\mat|\marg{arg}\\
% A macro for a matrix. Example: \verb*|\mat{A}| gives \mat{A}
% \end{macro}
% 
% \begin{macro}{\trans}
% \verb*|\trans|\marg{arg}\\
% A macro for the tranpose. Example: \verb*|\mat{A}\trans| gives $\mat{A}\trans$\\
% \end{macro}
%
% \begin{macro}{\cond}
% \begin{macro}{\diag}
% These macros are math opterators:
% \begin{center}\begin{tabular}{|c|c|}
%   	\hline Command & Symbol \\\hline\hline
% 		\verb*|\cond| & $\cond$\\\hline
% 		\verb*|\diag| & $\diag$\\\hline
% \end{tabular}\end{center}
% \end{macro}
% \end{macro}
%
% \subsection{\texttt{all}}\label{sec:all}
% This option is a shortcut for all the following options, i.e.~all defined macros are available. 
%
% \subsection{\texttt{spaces}}\label{sec:spaces}
% Here are currently no additional macros defined
%
% \subsection{\texttt{operators}}\label{sec:operators}
% \begin{macro}{\pnorm}\label{mac:pnorm}
% \begin{macro}{\maxnorm}\label{mac:maxnorm}
% \begin{macro}{\infnorm}\label{mac:infnorm}
% \begin{macro}{\onenorm}\label{mac:onenorm}
% \begin{macro}{\twonorm}\label{mac:twonorm}
%	These macros are special cases of \verb|\norm|.
% \end{macro}
% \end{macro}
% \end{macro}
% \end{macro}
% \end{macro}
%
% \section{Implementation}
% The implementation is shown and explained in this section. 
% ^^A The following is extracted in the .sty file. 
% \iffalse
\newcommand{\packagename}{macros}
\RequirePackage{etoolbox}
\RequirePackage{xspace}
\RequirePackage{amsmath}
\RequirePackage{amssymb}

%% Definition of bool variables
\newbool{main}
\newbool{all}
\newbool{spaces}
\newbool{operators}
\newbool{diffoperators}
\newbool{vectors}
\newbool{vectorcomponents}
\newbool{matrices}
\newbool{names}
\newbool{functions}
\newbool{fit}
\newbool{lumped}


%% Initialising bool variables
\booltrue{main}
\boolfalse{all}
\boolfalse{spaces}
\boolfalse{operators}
\boolfalse{diffoperators}
\boolfalse{vectors}
\boolfalse{vectorcomponents}
\boolfalse{matrices}
\boolfalse{names}
\boolfalse{functions}
\boolfalse{fit}
\boolfalse{lumped}

%% Declaring package options
\DeclareOption{spaces}{\booltrue{spaces}}
\DeclareOption{operators}{\booltrue{operators}}
\DeclareOption{diffoperators}{\booltrue{diffoperators}}
\DeclareOption{vectors}{\booltrue{vectors}}
\DeclareOption{vectorcomponents}{\booltrue{vectorcomponents}}
\DeclareOption{matrices}{\booltrue{matrices}}
\DeclareOption{names}{\booltrue{names}}
\DeclareOption{functions}{\booltrue{functions}}
\DeclareOption{fit}{\booltrue{fit}}
\DeclareOption{lumped}{\booltrue{lumped}}
\DeclareOption{all}{\booltrue{all}}
\DeclareOption*{\PackageWarning{\packagename}{Unknown ‘\CurrentOption’}}

%% Default options
%\ExecuteOptions{default}

\ProcessOptions\relax
\ifbool{all}{%Set all booleans to true
    \booltrue{spaces}
    \booltrue{operators}
    \booltrue{diffoperators}
    \booltrue{vectors}
    \booltrue{vectorcomponents}
    \booltrue{matrices}
    \booltrue{names}
    \booltrue{functions}
    \booltrue{fit}
    \booltrue{lumped}
}{}

\ifbool{main}{
    \newcommand{\cmplx}[1]{\ensuremath{\underline{#1}}\xspace}				% Complex entities
    \newcommand{\tensor}[1]{\ensuremath{\overline{\overline{#1}}}\xspace}	% Tensors
    
    % Constants
    \let\i\undefined
    \newcommand{\i}{\ensuremath{\mathrm{i}}\xspace}							% unit imaginary number
    \let\j\undefined
    \newcommand{\j}{\ensuremath{\mathrm{j}}\xspace}							% unit imaginary number
    \let\e\undefined
    \newcommand{\e}{\ensuremath{\mathrm{e}}\xspace}							% Euler number
    
    % Greek Letters with and without var
    \newbool{varphi}
    \boolfalse{varphi}
    \let\phi@norm\phi
    \let\phi@var\varphi
    \renewcommand{\phi}[1][]{
        \ifstrempty{#1}{\ifbool{varphi}{\phi@var}{\phi@norm}}
        {\ifstrequal{#1}{norm}{\phi@norm}{
            \ifstrequal{#1}{var}{\phi@var}{
                \PackageError{\packagename}{Parameter #1 is not defined for
                the macro \phi}{The input parameter #1 that was passed to the
                macro \phi[] is not defined. Use none or one of the following 
                input paramters: norm, var.}
            }
        }}
    }
      
    \newbool{varepsilon}
    \boolfalse{varepsilon}
    \let\epsilon@norm\epsilon
    \let\epsilon@var\varepsilon
    \renewcommand{\epsilon}[1][]{
        \ifstrempty{#1}{\ifbool{varepsilon}{\epsilon@var}{\epsilon@norm}}
        {\ifstrequal{#1}{norm}{\epsilon@norm}
            {\ifstrequal{#1}{var}{\epsilon@var}{
                \PackageError{\packagename}{Parameter #1 is not defined for 
                the macro \epsilon}{The input parameter #1 that was passed 
                to the macro \epsilon[] is not defined. Use none or one of 
                the following input paramters: norm, var.}
            }
        }}
    }
    
    \newbool{vartheta}
    \boolfalse{vartheta}
    \let\theta@norm\theta
    \let\theta@var\vartheta
    \renewcommand{\theta}[1][]{\ifstrempty{#1}{\ifbool{vartheta}{\theta@var}{\theta@norm}}{\ifstrequal{#1}{norm}{\theta@norm}{\ifstrequal{#1}{var}{\theta@var}{\PackageError{\packagename}{Parameter #1 is not defined for the macro \theta}{The input parameter #1 that was passed to the macro \theta[] is not defined. Use none or one of the following input paramters: norm, var.}}}}}
    
    \newbool{varrho}
    \boolfalse{varrho}
    \let\rho@norm\rho
    \let\rho@var\varrho
    \renewcommand{\rho}[1][]{\ifstrempty{#1}{\ifbool{varrho}{\rho@var}{\rho@norm}}{\ifstrequal{#1}{norm}{\rho@norm}{\ifstrequal{#1}{var}{\rho@var}{\PackageError{\packagename}{Parameter #1 is not defined for the macro \rho}{The input parameter #1 that was passed to the macro \rho[] is not defined. Use none or one of the following input paramters: norm, var.}}}}}
}{}


%% Spaces
\ifbool{main}{
    % number systems
    \newcommand{\nat}{\ensuremath{\mathbb{N}}}			% Natural numbers
    \newcommand{\integer}{\ensuremath{\mathbb{Z}}}		% Integers
    \newcommand{\rational}{\ensuremath{\mathbb{Q}}} 	% Rational numbers
    \newcommand{\real}{\ensuremath{\mathbb{R}}}			% Real numbers
    \newcommand{\complex}{\ensuremath{\mathbb{C}}}		% Complex numbers
}{}
\ifbool{spaces}{
    % To be extended
}{}


%% Operators
\ifbool{main}{
    \newcommand{\norm}[1]{\ensuremath{\left\lVert#1\right\rVert}}						% norm
    \newcommand{\abs}[1]{\ensuremath{\left|#1\right|}}									% Absolute value
    \DeclareMathOperator{\landau}{\ensuremath{\mathcal{O}}}              	% Landau symbol
    
    % Miscellaneous operators
    % Many common operators are availabel within amsmath
    \DeclareMathOperator{\supp}{supp}								% Support
    \DeclareMathOperator{\spn}{span}								% Span
    
    % Inner product
    \newcommand{\innerprod}[2]{\ensuremath{\left\langle#1\,,#2\right\rangle}}		% inner product
    
    % Set
    \newcommand{\set}[1]{\ensuremath{\left\{#1\right\}}}							% An ordinary set
}{}
\ifbool{operators}{
    \newcommand{\setdelimiter}{:}
    
    % Norms
    \newcommand{\pnorm}[2]{\norm{#1}_{#2}}
    \newcommand{\maxnorm}[1]{\pnorm{#1}{\mathrm{max}}}		% max-norm
    \newcommand{\infnorm}[1]{\pnorm{#1}{\infty}}			% infinity-norm
    \newcommand{\onenorm}[1]{\pnorm{#1}{1}}					% 1-norm
    \newcommand{\twonorm}[1]{\pnorm{#1}{2}}					% 2-norm
    
    \newcommand{\setprop}[2]{\left\{#1\setdelimiter#2\right\}}		% A set with properties
    
    % Real and imaginary part
    \let\Re\undefined
    \let\Im\undefined
    \DeclareMathOperator{\Re}{\mathcal{R}\mathrm{e}}
    \DeclareMathOperator{\Im}{\mathcal{I}\mathrm{m}}
    
    \newcommand{\lincomb}[2]{\left\{\begin{array}{c}#1 \\#2\end{array}\right\}}  % linear combination (for solutions while separating variables)
}{}


%% differential opeators
\ifbool{main}{
    \newcommand{\diff}{\ensuremath{\mathrm{d}}}
    \newcommand{\dd}[3][]{\ensuremath{\frac{\diff^{#1} #2}{\diff #3^{#1}}}}
    \newcommand{\pp}[3][]{\ensuremath{\frac{\partial^{#1} #2}{\partial #3^{#1}}}}
    
    \newbool{nabla}			% Boolean for usage of \nabla for differential operators. true: \nabla is used, false \nabla is not used
    \boolfalse{nabla}
    
    % Vector calculus operators as words
    \DeclareMathOperator{\grad@word}{grad}
    \DeclareMathOperator{\rot@word}{rot}
    \DeclareMathOperator{\curl@word}{curl}
    \DeclareMathOperator{\div@word}{div}
    
    % Vector calculus operators with nabla
    \newcommand{\grad@symbol}{\nabla}
    \newcommand{\rot@symbol}{\nabla\times}
    \newcommand{\curl@symbol}{\nabla\times}
    \newcommand{\div@symbol}{\nabla\cdot}
    
    % The following commands can be used with:
    %	- no input vairable: Decide with the bool nabla what is printed
    %	- with \...[nabla]: Use the symbol with nabla
    %	- with \...[word]:	Use the word
    \newcommand{\Grad}[1][]{\ifstrempty{#1}{\ifbool{nabla}{\grad@symbol}{\grad@word}}{\ifstrequal{#1}{nabla}{\grad@symbol}{\ifstrequal{#1}{word}{\grad@word}{\PackageError{\packagename}{Parameter #1 is not defined for the macro \grad.}{The input parameter #1 that was passed to the macro \grad is not defined. Use none or one of the following input paramters: nabla, word.}}}}}
    \newcommand{\Div}[1][]{\ifstrempty{#1}{\ifbool{nabla}{\div@symbol}{\div@word}}{\ifstrequal{#1}{nabla}{\div@symbol}{\ifstrequal{#1}{word}{\div@word}{\PackageError{\packagename}{Parameter #1 is not defined for the macro \div.}{The input parameter #1 that was passed to the macro \div is not defined. Use none or one of the following input paramters: nabla, word.}}}}}
    \newcommand{\Rot}[1][]{\ifstrempty{#1}{\ifbool{nabla}{\rot@symbol}{\rot@word}}{\ifstrequal{#1}{nabla}{\rot@symbol}{\ifstrequal{#1}{word}{\rot@word}{\PackageError{\packagename}{Parameter #1 is not defined for the macro \rot.}{The input parameter #1 that was passed to the macro \rot is not defined. Use none or one of the following input paramters: nabla, word.}}}}}
    \newcommand{\Curl}[1][]{\ifstrempty{#1}{\ifbool{nabla}{\curl@symbol}{\curl@word}}{\ifstrequal{#1}{nabla}{\curl@symbol}{\ifstrequal{#1}{word}{\curl@word}{\PackageError{\packagename}{Parameter #1 is not defined for the macro \curl.}{The input parameter #1 that was passed to the macro \curl is not defined. Use none or one of the following input paramters: nabla, word.}}}}}
}{}
\ifbool{diffoperators}{
    % special derivatives
    \newcommand{\ddx}{\dd{}{x}}
    \newcommand{\ddxx}{\dd[2]{}{x}}
    \newcommand{\ppx}{\pp{}{x}}
    \newcommand{\ppxx}{\pp[2]{}{x}}
    
    \newcommand{\ddy}{\dd{}{y}}
    \newcommand{\ddyy}{\dd[2]{}{y}}
    \newcommand{\ppy}{\pp{}{y}}
    \newcommand{\ppyy}{\pp[2]{}{y}}
    
    \newcommand{\ddz}{\dd{}{z}}
    \newcommand{\ddzz}{\dd[2]{}{z}}
    \newcommand{\ppz}{\pp{}{z}}
    \newcommand{\ppzz}{\pp[2]{}{z}}
    
    \newcommand{\ddrho}{\dd{}{\rho}}
    \newcommand{\ddrhorho}{\dd[2]{}{\rho}}
    \newcommand{\pprho}{\pp{}{\rho}}
    \newcommand{\pprhorho}{\pp[2]{}{\rho}}
    
    \newcommand{\ddphi}{\dd{}{\phi}}
    \newcommand{\ddphiphi}{\dd[2]{}{\phi}}
    \newcommand{\ppphi}{\pp{}{\phi}}
    \newcommand{\ppphiphi}{\pp[2]{}{\phi}}
    
    \newcommand{\ddtheta}{\dd{}{\theta}}
    \newcommand{\ddthetatheta}{\dd[2]{}{\theta}}
    \newcommand{\pptheta}{\pp{}{\theta}}
    \newcommand{\ppthetatheta}{\pp[2]{}{\theta}}
    
    \newcommand{\ddr}{\dd{}{r}}
    \newcommand{\ddrr}{\dd[2]{}{r}}
    \newcommand{\ppr}{\pp{}{r}}
    \newcommand{\pprr}{\pp[2]{}{r}}
    
    \newcommand{\dsv}{\diff \vec{s}}
    \newcommand{\dAv}{\diff \vec{A}}
    \newcommand{\ds}{\diff s}
    \newcommand{\dA}{\diff A}
    \newcommand{\dV}{\diff V}
    \newcommand{\dx}{\diff x}
    \newcommand{\dy}{\diff y}
    \newcommand{\dz}{\diff z}
    \newcommand{\dt}{\diff t}
    \newcommand{\dr}{\diff r}
    \newcommand{\drho}{\diff \rho}
    \newcommand{\dphi}{\diff \phi}
    \newcommand{\dtheta}{\diff \theta}
}{}


%% Vectors
\ifbool{main}{
    \newcommand{\vect}[1]{\ensuremath{\vec{#1}}}					% Vectors
    \newcommand{\cmplxvect}[1]{\cmplx{\vect{#1}}}					% Complex vectors
}{}
\ifbool{vectors}{
    % unity vectors
    % With the optional argument, the subscript can be extended
    \newcommand{\ex}[1][]{\ensuremath{\vect{e}_{x#1}}}
    \newcommand{\ey}[1][]{\ensuremath{\vect{e}_{y#1}}}
    \newcommand{\ez}[1][]{\ensuremath{\vect{e}_{z#1}}}
    \newcommand{\eu}[1][]{\ensuremath{\vect{e}_{u#1}}}
    \newcommand{\ev}[1][]{\ensuremath{\vect{e}_{v#1}}}
    \newcommand{\ew}[1][]{\ensuremath{\vect{e}_{w#1}}}
    \newcommand{\erho}[1][]{\ensuremath{\vect{e}_{\rho#1}}}
    \newcommand{\ephi}[1][]{\ensuremath{\vect{e}_{\phi#1}}}
    \newcommand{\er}[1][]{\ensuremath{\vect{e}_{r#1}}}
    \newcommand{\etheta}[1][]{\ensuremath{\vect{e}_{\theta#1}}}
    \newcommand{\en}[1][]{\ensuremath{\vect{e}_{\mathrm{n}#1}}}	% Normal component
    \newcommand{\et}[1][]{\ensuremath{\vect{e}_{\mathrm{t}#1}}}	% Tangential component
    
    % normal vector
    \newcommand{\nv}{\ensuremath{\vect{n}}}
    
    %%  Real vectors
    \newcommand{\Ev}{\ensuremath{\vect{E}}}				% Electrical field
    \newcommand{\Dv}{\ensuremath{\vect{D}}}				% Electric displacement field
    \newcommand{\Hv}{\ensuremath{\vect{H}}}				% Magnetic field strength
    \newcommand{\Bv}{\ensuremath{\vect{B}}}				% Magnetic flux density
    \newcommand{\Pv}{\ensuremath{\vect{P}}}				% Electric dipole moments
    \newcommand{\Jv}{\ensuremath{\vect{J}}}				% Current density
    \newcommand{\Av}{\ensuremath{\vect{A}}}				% Magnetic vector potential
    \newcommand{\Mv}{\ensuremath{\vect{M}}}				% Magnetization
    \newcommand{\Fv}{\ensuremath{\vect{F}}}				% Force
    \newcommand{\Sv}{\ensuremath{\vect{S}}}				% Pointing vector
    
    %%  Complex vectors (phasors)
    \newcommand{\Evc}{\ensuremath{\cmplxvect{E}}}				% Electrical field
    \newcommand{\Dvc}{\ensuremath{\cmplxvect{D}}}				% Electric displacement field
    \newcommand{\Hvc}{\ensuremath{\cmplxvect{H}}}				% Magnetic field strength
    \newcommand{\Bvc}{\ensuremath{\cmplxvect{B}}}				% Magnetic flux density
    \newcommand{\Pvc}{\ensuremath{\cmplxvect{P}}}				% Electric dipole moments
    \newcommand{\Jvc}{\ensuremath{\cmplxvect{J}}}				% Current density
    \newcommand{\Avc}{\ensuremath{\cmplxvect{A}}}				% Magnetic vector potential
    \newcommand{\Mvc}{\ensuremath{\cmplxvect{M}}}				% Magnetization
    \newcommand{\Fvc}{\ensuremath{\cmplxvect{F}}}				% Force
    \newcommand{\Svc}{\ensuremath{\cmplxvect{S}}}				% Pointing vector
}{}


%% Vectorcomponents
\ifbool{vectorcomponents}{
    % With the optional argument, the subscript can be extended. This holds for every vector component
    
    %% Components of real vectors
    % x components
    \newcommand{\Ex}[1][]{\ensuremath{E_{x#1}}}				% Electrical field (x component)
    \newcommand{\Dx}[1][]{\ensuremath{D_{x#1}}}				% Electric displacement field (x component)
    \newcommand{\Hx}[1][]{\ensuremath{H_{x#1}}}				% Magnetic field strength (x component)
    \newcommand{\Bx}[1][]{\ensuremath{B_{x#1}}}				% Magnetic flux density (x component)
    \newcommand{\Px}[1][]{\ensuremath{P_{x#1}}}				% Electric dipole moments (x component)
    \newcommand{\Jx}[1][]{\ensuremath{J_{x#1}}}				% Current density (x component)
    \newcommand{\Ax}[1][]{\ensuremath{A_{x#1}}}				% Magnetic vector potential (x component)
    \newcommand{\Mx}[1][]{\ensuremath{M_{x#1}}}				% Magnetization (x component)
    \newcommand{\Fx}[1][]{\ensuremath{F_{x#1}}}				% Force (x component)
    \newcommand{\Sx}[1][]{\ensuremath{S_{x#1}}}				% Pointing vector (x component)
    
    % y components
    \newcommand{\Ey}[1][]{\ensuremath{E_{y#1}}}				% Electrical field (y component)
    \newcommand{\Dy}[1][]{\ensuremath{D_{y#1}}}				% Electric displacement field (y component)
    \newcommand{\Hy}[1][]{\ensuremath{H_{y#1}}}				% Magnetic field strength (y component)
    \newcommand{\By}[1][]{\ensuremath{B_{y#1}}}				% Magnetic flux density (y component)
    \newcommand{\Py}[1][]{\ensuremath{P_{y#1}}}				% Electric dipole moments (y component)
    \newcommand{\Jy}[1][]{\ensuremath{J_{y#1}}}				% Current density (y component)
    \newcommand{\Ay}[1][]{\ensuremath{A_{y#1}}}				% Magnetic vector potential (y component)
    \newcommand{\My}[1][]{\ensuremath{M_{y#1}}}				% Magnetization (y component)
    \newcommand{\Fy}[1][]{\ensuremath{F_{y#1}}}				% Force (y component)
    \newcommand{\Sy}[1][]{\ensuremath{S_{y#1}}}				% Pointing vector (y component)
    
    % z components
    \newcommand{\Ez}[1][]{\ensuremath{E_{z#1}}}				% Electrical field (z component)
    \newcommand{\Dz}[1][]{\ensuremath{D_{z#1}}}				% Electric displacement field (z component)
    \newcommand{\Hz}[1][]{\ensuremath{H_{z#1}}}				% Magnetic field strength (z component)
    \newcommand{\Bz}[1][]{\ensuremath{B_{z#1}}}				% Magnetic flux density (z component)
    \newcommand{\Pz}[1][]{\ensuremath{P_{z#1}}}				% Electric dipole moments (z component)
    \newcommand{\Jz}[1][]{\ensuremath{J_{z#1}}}				% Current density (z component)
    \newcommand{\Az}[1][]{\ensuremath{A_{z#1}}}				% Magnetic vector potential (z component)
    \newcommand{\Mz}[1][]{\ensuremath{M_{z#1}}}				% Magnetization (z component)
    \newcommand{\Fz}[1][]{\ensuremath{F_{z#1}}}				% Force (z component)
    \newcommand{\Sz}[1][]{\ensuremath{S_{z#1}}}				% Pointing vector (z component)
    
    % u components
    % \newcommand{\Eu}[1][]{\ensuremath{E_{u#1}}}				% Electrical field (u component)
    % \newcommand{\Du}[1][]{\ensuremath{D_{u#1}}}				% Electric displacement field (u component)
    % \newcommand{\Hu}[1][]{\ensuremath{H_{u#1}}}				% Magnetic field strength (u component)
    % \newcommand{\Bu}[1][]{\ensuremath{B_{u#1}}}				% Magnetic flux density (u component)
    % \newcommand{\Pu}[1][]{\ensuremath{P_{u#1}}}				% Electric dipole moments (u component)
    % \newcommand{\Ju}[1][]{\ensuremath{J_{u#1}}}				% Current density (u component)
    % \newcommand{\Au}[1][]{\ensuremath{A_{u#1}}}				% Magnetic vector potential (u component)
    % \newcommand{\Mu}[1][]{\ensuremath{M_{u#1}}}				% Magnetization (u component)
    % \newcommand{\Fu}[1][]{\ensuremath{F_{u#1}}}				% Force (u component)
    % \newcommand{\Su}[1][]{\ensuremath{S_{u#1}}}				% Pointing vector (u component)
    
    % v components
    % \newcommand{\Ev}[1][]{\ensuremath{E_{v#1}}}				% Electrical field (v component)
    % \newcommand{\Dv}[1][]{\ensuremath{D_{v#1}}}				% Electric displacement field (v component)
    % \newcommand{\Hv}[1][]{\ensuremath{H_{v#1}}}				% Magnetic field strength (v component)
    % \newcommand{\Bv}[1][]{\ensuremath{B_{v#1}}}				% Magnetic flux density (v component)
    % \newcommand{\Pv}[1][]{\ensuremath{P_{v#1}}}				% Electric dipole moments (v component)
    % \newcommand{\Jv}[1][]{\ensuremath{J_{v#1}}}				% Current density (v component)
    % \newcommand{\Av}[1][]{\ensuremath{A_{v#1}}}				% Magnetic vector potential (v component)
    % \newcommand{\Mv}[1][]{\ensuremath{M_{v#1}}}				% Magnetization (v component)
    % \newcommand{\Fv}[1][]{\ensuremath{F_{v#1}}}				% Force (v component)
    % \newcommand{\Sv}[1][]{\ensuremath{S_{v#1}}}				% Pointing vector (v component)
    
    % w components
    % \newcommand{\Ew}[1][]{\ensuremath{E_{w#1}}}				% Electrical field (w component)
    % \newcommand{\Dw}[1][]{\ensuremath{D_{w#1}}}				% Electric displacement field (w component)
    % \newcommand{\Hw}[1][]{\ensuremath{H_{w#1}}}				% Magnetic field strength (w component)
    % \newcommand{\Bw}[1][]{\ensuremath{B_{w#1}}}				% Magnetic flux density (w component)
    % \newcommand{\Pw}[1][]{\ensuremath{P_{w#1}}}				% Electric dipole moments (w component)
    % \newcommand{\Jw}[1][]{\ensuremath{J_{w#1}}}				% Current density (w component)
    % \newcommand{\Aw}[1][]{\ensuremath{A_{w#1}}}				% Magnetic vector potential (w component)
    % \newcommand{\Mw}[1][]{\ensuremath{M_{w#1}}}				% Magnetization (w component)
    % \newcommand{\Fw}[1][]{\ensuremath{F_{w#1}}}				% Force (w component)
    % \newcommand{\Sw}[1][]{\ensuremath{S_{w#1}}}				% Pointing vector (w component)
    
    % phi components
    \newcommand{\Ephi}[1][]{\ensuremath{E_{\phi#1}}}				% Electrical field (\phi component)
    \newcommand{\Dphi}[1][]{\ensuremath{D_{\phi#1}}}				% Electric displacement field (\phi component)
    \newcommand{\Hphi}[1][]{\ensuremath{H_{\phi#1}}}				% Magnetic field strength (\phi component)
    \newcommand{\Bphi}[1][]{\ensuremath{B_{\phi#1}}}				% Magnetic flux density (\phi component)
    \newcommand{\Pphi}[1][]{\ensuremath{P_{\phi#1}}}				% Electric dipole moments (\phi component)
    \newcommand{\Jphi}[1][]{\ensuremath{J_{\phi#1}}}				% Current density (\phi component)
    \newcommand{\Aphi}[1][]{\ensuremath{A_{\phi#1}}}				% Magnetic vector potential (\phi component)
    \newcommand{\Mphi}[1][]{\ensuremath{M_{\phi#1}}}				% Magnetization (\phi component)
    \newcommand{\Fphi}[1][]{\ensuremath{F_{\phi#1}}}				% Force (\phi component)
    \newcommand{\Sphi}[1][]{\ensuremath{S_{\phi#1}}}				% Pointing vector (\phi component)
    
    % rho components
    \newcommand{\Erho}[1][]{\ensuremath{E_{\rho#1}}}				% Electrical field (\rho component)
    \newcommand{\Drho}[1][]{\ensuremath{D_{\rho#1}}}				% Electric displacement field (\rho component)
    \newcommand{\Hrho}[1][]{\ensuremath{H_{\rho#1}}}				% Magnetic field strength (\rho component)
    \newcommand{\Brho}[1][]{\ensuremath{B_{\rho#1}}}				% Magnetic flux density (\rho component)
    \newcommand{\Prho}[1][]{\ensuremath{P_{\rho#1}}}				% Electric dipole moments (\rho component)
    \newcommand{\Jrho}[1][]{\ensuremath{J_{\rho#1}}}				% Current density (\rho component)
    \newcommand{\Arho}[1][]{\ensuremath{A_{\rho#1}}}				% Magnetic vector potential (\rho component)
    \newcommand{\Mrho}[1][]{\ensuremath{M_{\rho#1}}}				% Magnetization (\rho component)
    \newcommand{\Frho}[1][]{\ensuremath{F_{\rho#1}}}				% Force (\rho component)
    \newcommand{\Srho}[1][]{\ensuremath{S_{\rho#1}}}				% Pointing vector (\rho component)
    
    % r components
    \let\Pr\undefined
    \newcommand{\Er}[1][]{\ensuremath{E_{r#1}}}				% Electrical field (r component)
    \newcommand{\Dr}[1][]{\ensuremath{D_{r#1}}}				% Electric displacement field (r component)
    \newcommand{\Hr}[1][]{\ensuremath{H_{r#1}}}				% Magnetic field strength (r component)
    \newcommand{\Br}[1][]{\ensuremath{B_{r#1}}}				% Magnetic flux density (r component)
    \newcommand{\Pr}[1][]{\ensuremath{P_{r#1}}}				% Electric dipole moments (r component)
    \newcommand{\Jr}[1][]{\ensuremath{J_{r#1}}}				% Current density (r component)
    \newcommand{\Ar}[1][]{\ensuremath{A_{r#1}}}				% Magnetic vector potential (r component)
    \newcommand{\Mr}[1][]{\ensuremath{M_{r#1}}}				% Magnetization (r component)
    \newcommand{\Fr}[1][]{\ensuremath{F_{r#1}}}				% Force (r component)
    \newcommand{\Sr}[1][]{\ensuremath{S_{r#1}}}				% Pointing vector (r component)
    
    % theta components
    \newcommand{\Etheta}[1][]{\ensuremath{E_{\theta#1}}}				% Electrical field (\theta component)
    \newcommand{\Dtheta}[1][]{\ensuremath{D_{\theta#1}}}				% Electric displacement field (\theta component)
    \newcommand{\Htheta}[1][]{\ensuremath{H_{\theta#1}}}				% Magnetic field strength (\theta component)
    \newcommand{\Btheta}[1][]{\ensuremath{B_{\theta#1}}}				% Magnetic flux density (\theta component)
    \newcommand{\Ptheta}[1][]{\ensuremath{P_{\theta#1}}}				% Electric dipole moments (\theta component)
    \newcommand{\Jtheta}[1][]{\ensuremath{J_{\theta#1}}}				% Current density (\theta component)
    \newcommand{\Atheta}[1][]{\ensuremath{A_{\theta#1}}}				% Magnetic vector potential (\theta component)
    \newcommand{\Mtheta}[1][]{\ensuremath{M_{\theta#1}}}				% Magnetization (\theta component)
    \newcommand{\Ftheta}[1][]{\ensuremath{F_{\theta#1}}}				% Force (\theta component)
    \newcommand{\Stheta}[1][]{\ensuremath{S_{\theta#1}}}				% Pointing vector (\theta component)
    
    
    %% Components of complex vectors
    % x components
    \newcommand{\Exc}[1][]{\ensuremath{\cmplx{E}_{x#1}}}				% Electrical field (x component)
    \newcommand{\Dxc}[1][]{\ensuremath{\cmplx{D}_{x#1}}}				% Electric displacement field (x component)
    \newcommand{\Hxc}[1][]{\ensuremath{\cmplx{H}_{x#1}}}				% Magnetic field strength (x component)
    \newcommand{\Bxc}[1][]{\ensuremath{\cmplx{B}_{x#1}}}				% Magnetic flux density (x component)
    \newcommand{\Pxc}[1][]{\ensuremath{\cmplx{P}_{x#1}}}				% Electric dipole moments (x component)
    \newcommand{\Jxc}[1][]{\ensuremath{\cmplx{J}_{x#1}}}				% Current density (x component)
    \newcommand{\Axc}[1][]{\ensuremath{\cmplx{A}_{x#1}}}				% Magnetic vector potential (x component)
    \newcommand{\Mxc}[1][]{\ensuremath{\cmplx{M}_{x#1}}}				% Magnetization (x component)
    \newcommand{\Fxc}[1][]{\ensuremath{\cmplx{F}_{x#1}}}				% Force (x component)
    \newcommand{\Sxc}[1][]{\ensuremath{\cmplx{S}_{x#1}}}				% Pointing vector (x component)
    
    % y components
    \newcommand{\Eyc}[1][]{\ensuremath{\cmplx{E}_{y#1}}}				% Electrical field (y component)
    \newcommand{\Dyc}[1][]{\ensuremath{\cmplx{D}_{y#1}}}				% Electric displacement field (y component)
    \newcommand{\Hyc}[1][]{\ensuremath{\cmplx{H}_{y#1}}}				% Magnetic field strength (y component)
    \newcommand{\Byc}[1][]{\ensuremath{\cmplx{B}_{y#1}}}				% Magnetic flux density (y component)
    \newcommand{\Pyc}[1][]{\ensuremath{\cmplx{P}_{y#1}}}				% Electric dipole moments (y component)
    \newcommand{\Jyc}[1][]{\ensuremath{\cmplx{J}_{y#1}}}				% Current density (y component)
    \newcommand{\Ayc}[1][]{\ensuremath{\cmplx{A}_{y#1}}}				% Magnetic vector potential (y component)
    \newcommand{\Myc}[1][]{\ensuremath{\cmplx{M}_{y#1}}}				% Magnetization (y component)
    \newcommand{\Fyc}[1][]{\ensuremath{\cmplx{F}_{y#1}}}				% Force (y component)
    \newcommand{\Syc}[1][]{\ensuremath{\cmplx{S}_{y#1}}}				% Pointing vector (y component)
    
    % z components
    \newcommand{\Ezc}[1][]{\ensuremath{\cmplx{E}_{z#1}}}				% Electrical field (z component)
    \newcommand{\Dzc}[1][]{\ensuremath{\cmplx{D}_{z#1}}}				% Electric displacement field (z component)
    \newcommand{\Hzc}[1][]{\ensuremath{\cmplx{H}_{z#1}}}				% Magnetic field strength (z component)
    \newcommand{\Bzc}[1][]{\ensuremath{\cmplx{B}_{z#1}}}				% Magnetic flux density (z component)
    \newcommand{\Pzc}[1][]{\ensuremath{\cmplx{P}_{z#1}}}				% Electric dipole moments (z component)
    \newcommand{\Jzc}[1][]{\ensuremath{\cmplx{J}_{z#1}}}				% Current density (z component)
    \newcommand{\Azc}[1][]{\ensuremath{\cmplx{A}_{z#1}}}				% Magnetic vector potential (z component)
    \newcommand{\Mzc}[1][]{\ensuremath{\cmplx{M}_{z#1}}}				% Magnetization (z component)
    \newcommand{\Fzc}[1][]{\ensuremath{\cmplx{F}_{z#1}}}				% Force (z component)
    \newcommand{\Szc}[1][]{\ensuremath{\cmplx{S}_{z#1}}}				% Pointing vector (z component)
    
    % u components
    % \newcommand{\Euc}[1][]{\ensuremath{\cmplx{E}_{u#1}}}				% Electrical field (u component)
    % \newcommand{\Duc}[1][]{\ensuremath{\cmplx{D}_{u#1}}}				% Electric displacement field (u component)
    % \newcommand{\Huc}[1][]{\ensuremath{\cmplx{H}_{u#1}}}				% Magnetic field strength (u component)
    % \newcommand{\Buc}[1][]{\ensuremath{\cmplx{B}_{u#1}}}				% Magnetic flux density (u component)
    % \newcommand{\Puc}[1][]{\ensuremath{\cmplx{P}_{u#1}}}				% Electric dipole moments (u component)
    % \newcommand{\Juc}[1][]{\ensuremath{\cmplx{J}_{u#1}}}				% Current density (u component)
    % \newcommand{\Auc}[1][]{\ensuremath{\cmplx{A}_{u#1}}}				% Magnetic vector potential (u component)
    % \newcommand{\Muc}[1][]{\ensuremath{\cmplx{M}_{u#1}}}				% Magnetiuation (u component)
    % \newcommand{\Fuc}[1][]{\ensuremath{\cmplx{F}_{u#1}}}				% Force (u component)
    % \newcommand{\Suc}[1][]{\ensuremath{\cmplx{S}_{u#1}}}				% Pointing vector (u component)
    
    % v components
    % \newcommand{\Evc}[1][]{\ensuremath{\cmplx{E}_{v#1}}}				% Electrical field (v component)
    % \newcommand{\Dvc}[1][]{\ensuremath{\cmplx{D}_{v#1}}}				% Electric displacement field (v component)
    % \newcommand{\Hvc}[1][]{\ensuremath{\cmplx{H}_{v#1}}}				% Magnetic field strength (v component)
    % \newcommand{\Bvc}[1][]{\ensuremath{\cmplx{B}_{v#1}}}				% Magnetic flux density (v component)
    % \newcommand{\Pvc}[1][]{\ensuremath{\cmplx{P}_{v#1}}}				% Electric dipole moments (v component)
    % \newcommand{\Jvc}[1][]{\ensuremath{\cmplx{J}_{v#1}}}				% Current density (v component)
    % \newcommand{\Avc}[1][]{\ensuremath{\cmplx{A}_{v#1}}}				% Magnetic vector potential (v component)
    % \newcommand{\Mvc}[1][]{\ensuremath{\cmplx{M}_{v#1}}}				% Magnetivation (v component)
    % \newcommand{\Fvc}[1][]{\ensuremath{\cmplx{F}_{v#1}}}				% Force (v component)
    % \newcommand{\Svc}[1][]{\ensuremath{\cmplx{S}_{v#1}}}				% Pointing vector (v component)
    
    % w components
    % \newcommand{\Ewc}[1][]{\ensuremath{\cmplx{E}_{w#1}}}				% Electrical field (w component)
    % \newcommand{\Dwc}[1][]{\ensuremath{\cmplx{D}_{w#1}}}				% Electric displacement field (w component)
    % \newcommand{\Hwc}[1][]{\ensuremath{\cmplx{H}_{w#1}}}				% Magnetic field strength (w component)
    % \newcommand{\Bwc}[1][]{\ensuremath{\cmplx{B}_{w#1}}}				% Magnetic flux density (w component)
    % \newcommand{\Pwc}[1][]{\ensuremath{\cmplx{P}_{w#1}}}				% Electric dipole moments (w component)
    % \newcommand{\Jwc}[1][]{\ensuremath{\cmplx{J}_{w#1}}}				% Current density (w component)
    % \newcommand{\Awc}[1][]{\ensuremath{\cmplx{A}_{w#1}}}				% Magnetic vector potential (w component)
    % \newcommand{\Mwc}[1][]{\ensuremath{\cmplx{M}_{w#1}}}				% Magnetiwation (w component)
    % \newcommand{\Fwc}[1][]{\ensuremath{\cmplx{F}_{w#1}}}				% Force (w component)
    % \newcommand{\Swc}[1][]{\ensuremath{\cmplx{S}_{w#1}}}				% Pointing vector (w component)
    
    % phi components
    \newcommand{\Ephic}[1][]{\ensuremath{\cmplx{E}_{\phi#1}}}				% Electrical field (\phi component)
    \newcommand{\Dphic}[1][]{\ensuremath{\cmplx{D}_{\phi#1}}}				% Electric displacement field (\phi component)
    \newcommand{\Hphic}[1][]{\ensuremath{\cmplx{H}_{\phi#1}}}				% Magnetic field strength (\phi component)
    \newcommand{\Bphic}[1][]{\ensuremath{\cmplx{B}_{\phi#1}}}				% Magnetic flux density (\phi component)
    \newcommand{\Pphic}[1][]{\ensuremath{\cmplx{P}_{\phi#1}}}				% Electric dipole moments (\phi component)
    \newcommand{\Jphic}[1][]{\ensuremath{\cmplx{J}_{\phi#1}}}				% Current density (\phi component)
    \newcommand{\Aphic}[1][]{\ensuremath{\cmplx{A}_{\phi#1}}}				% Magnetic vector potential (\phi component)
    \newcommand{\Mphic}[1][]{\ensuremath{\cmplx{M}_{\phi#1}}}				% Magnetization (\phi component)
    \newcommand{\Fphic}[1][]{\ensuremath{\cmplx{F}_{\phi#1}}}				% Force (\phi component)
    \newcommand{\Sphic}[1][]{\ensuremath{\cmplx{S}_{\phi#1}}}				% Pointing vector (\phi component)
    
    % rho components
    \newcommand{\Erhoc}[1][]{\ensuremath{\cmplx{E}_{\rho#1}}}				% Electrical field (\rho component)
    \newcommand{\Drhoc}[1][]{\ensuremath{\cmplx{D}_{\rho#1}}}				% Electric displacement field (\rho component)
    \newcommand{\Hrhoc}[1][]{\ensuremath{\cmplx{H}_{\rho#1}}}				% Magnetic field strength (\rho component)
    \newcommand{\Brhoc}[1][]{\ensuremath{\cmplx{B}_{\rho#1}}}				% Magnetic flux density (\rho component)
    \newcommand{\Prhoc}[1][]{\ensuremath{\cmplx{P}_{\rho#1}}}				% Electric dipole moments (\rho component)
    \newcommand{\Jrhoc}[1][]{\ensuremath{\cmplx{J}_{\rho#1}}}				% Current density (\rho component)
    \newcommand{\Arhoc}[1][]{\ensuremath{\cmplx{A}_{\rho#1}}}				% Magnetic vector potential (\rho component)
    \newcommand{\Mrhoc}[1][]{\ensuremath{\cmplx{M}_{\rho#1}}}				% Magnetization (\rho component)
    \newcommand{\Frhoc}[1][]{\ensuremath{\cmplx{F}_{\rho#1}}}				% Force (\rho component)
    \newcommand{\Srhoc}[1][]{\ensuremath{\cmplx{S}_{\rho#1}}}				% Pointing vector (\rho component)
    
    % r components
    \newcommand{\Erc}[1][]{\ensuremath{\cmplx{E}_{r#1}}}				% Electrical field (r component)
    \newcommand{\Drc}[1][]{\ensuremath{\cmplx{D}_{r#1}}}				% Electric displacement field (r component)
    \newcommand{\Hrc}[1][]{\ensuremath{\cmplx{H}_{r#1}}}				% Magnetic field strength (r component)
    \newcommand{\Brc}[1][]{\ensuremath{\cmplx{B}_{r#1}}}				% Magnetic flux density (r component)
    \newcommand{\Prc}[1][]{\ensuremath{\cmplx{P}_{r#1}}}				% Electric dipole moments (r component)
    \newcommand{\Jrc}[1][]{\ensuremath{\cmplx{J}_{r#1}}}				% Current density (r component)
    \newcommand{\Arc}[1][]{\ensuremath{\cmplx{A}_{r#1}}}				% Magnetic vector potential (r component)
    \newcommand{\Mrc}[1][]{\ensuremath{\cmplx{M}_{r#1}}}				% Magnetization (r component)
    \newcommand{\Frc}[1][]{\ensuremath{\cmplx{F}_{r#1}}}				% Force (r component)
    \newcommand{\Src}[1][]{\ensuremath{\cmplx{S}_{r#1}}}				% Pointing vector (r component)
    
    % theta components
    \newcommand{\Ethetac}[1][]{\ensuremath{\cmplx{E}_{\theta#1}}}				% Electrical field (\theta component)
    \newcommand{\Dthetac}[1][]{\ensuremath{\cmplx{D}_{\theta#1}}}				% Electric displacement field (\theta component)
    \newcommand{\Hthetac}[1][]{\ensuremath{\cmplx{H}_{\theta#1}}}				% Magnetic field strength (\theta component)
    \newcommand{\Bthetac}[1][]{\ensuremath{\cmplx{B}_{\theta#1}}}				% Magnetic flux density (\theta component)
    \newcommand{\Pthetac}[1][]{\ensuremath{\cmplx{P}_{\theta#1}}}				% Electric dipole moments (\theta component)
    \newcommand{\Jthetac}[1][]{\ensuremath{\cmplx{J}_{\theta#1}}}				% Current density (\theta component)
    \newcommand{\Athetac}[1][]{\ensuremath{\cmplx{A}_{\theta#1}}}				% Magnetic vector potential (\theta component)
    \newcommand{\Mthetac}[1][]{\ensuremath{\cmplx{M}_{\theta#1}}}				% Magnetization (\theta component)
    \newcommand{\Fthetac}[1][]{\ensuremath{\cmplx{F}_{\theta#1}}}				% Force (\theta component)
    \newcommand{\Sthetac}[1][]{\ensuremath{\cmplx{S}_{\theta#1}}}				% Pointing vector (\theta component)
}{}


%% Matrices
\ifbool{main}{
    \newcommand{\mat}[1]{\ensuremath{\mathbf{#1}}}					% Matrices
    \newcommand{\trans}{^{\mkern-1.5mu\mathsf{T}}}					% transpose
    
    \DeclareMathOperator{\cond}{cond}								% Codition number
    \DeclareMathOperator{\diag}{diag}								% diag operator
}{}
\ifbool{matrices}{
    % To be extended
}{}


%% Names
\ifbool{names}{ % Taken from temf-names.sty
    %% Software
    \newcommand{\comsol}{\textsc{COMSOL Multiphysics\textsuperscript{\textregistered}}\xspace}
    \newcommand{\cstcs}{\textsc{CST CABLE STUDIO\textsuperscript{\textregistered}}\xspace}
    \newcommand{\cstds}{\textsc{CST DESIGN STUDIO\textsuperscript{\texttrademark}}\xspace}
    \newcommand{\cstems}{\textsc{CST EM STUDIO\textsuperscript{\textregistered}}\xspace}
    \newcommand{\cstmws}{\textsc{CST MICROWAVE STUDIO\textsuperscript{\textregistered}} \xspace}
    \newcommand{\cstpcbs}{\textsc{CST PCB STUDIO\textsuperscript{\textregistered}}\xspace}
    \newcommand{\cstps}{\textsc{CST PARTICLE STUDIO\textsuperscript{\textregistered}}\xspace}
    \newcommand{\matlab}{\textsc{Matlab\textsuperscript{\textregistered}}\xspace}
    \newcommand{\mathematica}{\textsc{Mathematica\textsuperscript{\textregistered}}\xspace}
    \newcommand{\niobe}{\textsc{Niobe}\xspace}
    \newcommand{\octave}{\textsc{GNU Octave}\xspace}
    \newcommand{\OpenFOAM}{\textsc{OpenFOAM}\xspace}
    \newcommand{\petsc}{\textsc{PETSc}\xspace}
    \newcommand{\pspice}{\textsc{OrCAD PSpice\textsuperscript{\textregistered}}\xspace}
    
    %% Names
    \newcommand{\Ampere}{\textsc{Amp$\grave{\text{e}}$re}\xspace}
    \newcommand{\Bernoulli}{\textsc{Bernoulli}\xspace}
    \newcommand{\Cauer}{\textsc{Cauer}\xspace}
    \newcommand{\Coulomb}{\textsc{Coulomb}\xspace}
    \newcommand{\Courant}{\textsc{Courant}\xspace}
    \newcommand{\Dirichlet}{\textsc{Dirichlet}\xspace}
    \newcommand{\Euler}{\textsc{Euler}\xspace}
    \newcommand{\Faraday}{\textsc{Faraday}\xspace}
    \newcommand{\Foster}{\textsc{Foster}\xspace}
    \newcommand{\Fourier}{\textsc{Fourier}\xspace}
    \newcommand{\Friedrichs}{\textsc{Friedrichs}\xspace}
    \newcommand{\Gauss}{\textsc{Gauss}\xspace}
    \newcommand{\Green}{\textsc{Green}\xspace}
    \newcommand{\Henry}{\textsc{Henry}\xspace}
    \newcommand{\Joule}{\textsc{Joule}\xspace}
    \newcommand{\Kirchhoff}{\textsc{Kirchhoff}\xspace}
    \newcommand{\Laplace}{\textsc{Laplace}\xspace}
    \newcommand{\Leibniz}{\textsc{Leibniz}\xspace}
    \newcommand{\Levy}{\textsc{Levy}\xspace}
    \newcommand{\Lorentz}{\textsc{Lorentz}\xspace} %-% Hendrik Antoon, the one with forces
    \newcommand{\Lorenz}{\textsc{Lorenz}\xspace} %-% Ludvig, the one with gauging
    \newcommand{\Maxwell}{\textsc{Maxwell}\xspace}
    \newcommand{\Navier}{\textsc{Navier}\xspace}
    \newcommand{\Neumann}{\textsc{Neumann}\xspace}
    \newcommand{\Newton}{\textsc{Newton}\xspace}
    \newcommand{\Norton}{\textsc{Norton}\xspace}
    \newcommand{\Poisson}{\textsc{Poisson}\xspace}
    \newcommand{\Robin}{\textsc{Robin}\xspace}
    \newcommand{\Stokes}{\textsc{Stokes}\xspace}
    \newcommand{\Taylor}{\textsc{Taylor}\xspace}
    \newcommand{\Yee}{\textsc{Yee}\xspace}
    \newcommand{\Young}{\textsc{Young}\xspace}
}{}


%% functions
\ifbool{functions}{
    % supplment to trigonometric and hyperbolic functions. The missing functions are defined within amsmath
    \DeclareMathOperator{\csch}{csch}			% Hyperbolic cosecant
    \DeclareMathOperator{\sech}{sech}			% Hyperbolic secant
    \DeclareMathOperator{\arccsc}{arccsc}		% Inverse cosecant
    \DeclareMathOperator{\arcsec}{arcsec}		% Inverse secant
    \DeclareMathOperator{\arccot}{arccot}		% Inverse cotangent
    \DeclareMathOperator{\arsinh}{arsinh}		% Inverse hyperbolic sine
    \DeclareMathOperator{\arcosh}{arcosh}		% Inverse hyperbolic cosine
    \DeclareMathOperator{\artanh}{artanh}		% Inverse hyperbolic tangent
    \DeclareMathOperator{\arcsch}{arcsch}		% Inverse hyperbolic cosecant
    \DeclareMathOperator{\arsech}{arsech}		% Inverse hyperbolic secant
    \DeclareMathOperator{\arcoth}{arcoth}		% Inverse hyperbolic cotangent
    
    \DeclareMathOperator{\sinc}{sinc}			% sinc function
    \DeclareMathOperator{\cosc}{cosc}			% cosc function
    \DeclareMathOperator{\tanc}{tanc}			% tanc function
    \DeclareMathOperator{\sinhc}{sinhc}			% sinhc function
    \DeclareMathOperator{\coshc}{coshc}			% coshc function
    \DeclareMathOperator{\tanhc}{tanhc}			% tanhc function
    
    \DeclareMathOperator{\sign}{sign}								% Signum function
    
    % Bessel functions
    \newcommand{\besselFirst}[1]{\operatorname{J}_{#1}}				% Bessel function of first kind
    \newcommand{\besselSecond}[1]{\operatorname{N}_{#1}}			% Bessel function of second kind
    \newcommand{\modbesselFirst}[1]{\operatorname{I}_{#1}}			% Modified bessel function of first kind
    \newcommand{\modbesselSecond}[1]{\operatorname{K}_{#1}}			% Modified bessel function of second kind
    
    % Legendre functions
    \newcommand{\legendreFirst}[2]{\operatorname{P}^{#1}_{#2}}		% The associated Legendre functions of the first kind (zugeordnete Kugelfunktion erster Art)
    \newcommand{\legendreSecond}[2]{\operatorname{Q}^{#1}_{#2}}		% The associated Legendre functions of the second kind (zugeordnete Kugelfunktion zweiter Art)
}{}


%% FIt
\ifbool{fit}{
    %% FIT bow notation
    %% Taken from temf-finite.sty
    %% Authors: Erion Gjonaj, Thorben Casper
    \catcode`@=11
    \newcommand{\frownfill}{\ensuremath{\scriptscriptstyle\m@th\mathord\frown}}
    \newcommand{\bow}[1]{\ensuremath{\vbox{\m@th\ialign{##\crcr
                    \hfil\frownfill\hfil\crcr\noalign{\kern-0.2\p@\nointerlineskip}
                    $\hfil\displaystyle{#1}\hfil$\crcr}}}}
    \newcommand{\bbow}[1]{\ensuremath{\vbox{\m@th\ialign{##\crcr
                    \hfil\frownfill\hfil\crcr\noalign{\kern-0.7\p@\nointerlineskip}
                    \hfil\frownfill\hfil\crcr\noalign{\kern-0.3\p@\nointerlineskip}
                    $\hfil\displaystyle{#1}\hfil$\crcr}}}}
    \newcommand{\bbbow}[1]{\ensuremath{\vbox{\m@th\ialign{##\crcr
                    \hfil\frownfill\hfil\crcr\noalign{\kern-0.7\p@\nointerlineskip}
                    \hfil\frownfill\hfil\crcr\noalign{\kern-0.7\p@\nointerlineskip}
                    \hfil\frownfill\hfil\crcr\noalign{\kern-0.3\p@\nointerlineskip}
                    $\hfil\displaystyle{#1}\hfil$\crcr}}}}
    \newcommand{\widefrownfill}{\ensuremath{\m@th\mathord\frown}}
    \newcommand{\widebow}[1]{\ensuremath{\vbox{\m@th\ialign{##\crcr
                    \hfil\widefrownfill\hfil\crcr\noalign{\kern-0.9\p@\nointerlineskip}
                    $\hfil\displaystyle{#1}\hfil$\crcr}}}}
    \newcommand{\widebbow}[1]{\ensuremath{\vbox{\m@th\ialign{##\crcr
                    \hfil\widefrownfill\hfil\crcr\noalign{\kern-1.8\p@\nointerlineskip}
                    \hfil\widefrownfill\hfil\crcr\noalign{\kern-0.9\p@\nointerlineskip}
                    $\hfil\displaystyle{#1}\hfil$\crcr}}}}
    \newcommand{\widebbbow}[1]{\ensuremath{\vbox{\m@th\ialign{##\crcr
                    \hfil\widefrownfill\hfil\crcr\noalign{\kern-1.8\p@\nointerlineskip}
                    \hfil\widefrownfill\hfil\crcr\noalign{\kern-1.8\p@\nointerlineskip}
                    \hfil\widefrownfill\hfil\crcr\noalign{\kern-0.9\p@\nointerlineskip}
                    $\hfil\displaystyle{#1}\hfil$\crcr}}}}
    
    \newcommand{\dual}[1]{\protect\tilde{#1}}
    \newcommand{\widedual}[1]{\protect\widetilde{#1}}
}{}


%% Lumped elements
\ifbool{lumped}{
    \newcommand{\conductance}{\ensuremath{G}}
    \newcommand{\resistance}{\ensuremath{R}}
    \newcommand{\inductance}{\ensuremath{L}}
    \newcommand{\capacitance}{\ensuremath{C}}
    \newcommand{\charge}{\ensuremath{Q}}
    \newcommand{\voltsrc}{\ensuremath{V}}
    \newcommand{\currsrc}{\ensuremath{I}}
    \newcommand{\current}{\ensuremath{i}}
    \newcommand{\npot}{\ensuremath{\varphi}}
    \newcommand{\volt}{\ensuremath{u}}
}{}

\endinput
% \fi
%
% ^^A\StopEventually{\PrintIndex}
% \Finale
%
\endinput